## system plugin for jabberif
##	execute system commands
##
## written by Ben Fuhrmannek <bef@erlangen.ccc.de>
##
##
## remark: have a look on security issues when taking arguments from commands
##

import sys,os
from string import join
import SOAPpy

class system_plugin:
	def __init__(self, ph):
		self.ph = ph
		self.name = 'system_plugin'

		ph.register_command(self, 'who', self.who, 'system who', {'op_only':1})
		ph.register_command(self, 'uname', self.uname, 'system uname', {'op_only':1})

	def __system(self, cmd):
		p = os.popen(cmd)
		out = p.read()
		p.close()
		return out
		
	def __simple_cmd(self, args, cmd):
		output = self.__system(cmd)
		self.ph.send_back(args['con'], args['msg'], '\n'+output)

	def who(self, args):
		self.__simple_cmd(args, 'who')
		
	def uname(self, args):
		self.__simple_cmd(args, 'uname -a')

